<template>
<div class="feed-activity-list">
    <div class="feed-element" v-for="pan in pans.data" :key="pan.id">
        <div class="media-body ">
            <table class="table">
                <tbody>
                    <tr>
                        <th width="10%">Status</th>
                        <td width="20%">
                            : 
                            <span class="label label-primary" v-if="pan.is_saved">SAVED</span>
                            <span class="label label-warning" v-else>FOR UPDATE</span>

                            <span v-if="latestPan">
                                <span class="label label-success" v-if="latestPan.id == pan.id">
                                    Current PAN
                                </span>
                            </span>
                        </td>
                        <th width="10%">Effectivity</th>
                        <td>
                            : {{ pan.display_effectivity }}
                        </td>
                    </tr>
                    <tr>
                        <th>Nature</th>
                        <td>: {{ pan.nature }}</td>
                        <th>Pay Class</th>
                        <td>: {{ pan.pay_class }}</td>
                    </tr>
                    <tr>
                        <th>Position</th>
                        <td>: {{ pan.job_title }}</td>
                        <th>Basic Salary</th>
                        <td>: P {{ pan.basic_salary | formatNumber }}</td>
                    </tr>
                    <tr>
                        <th>Department</th>
                        <td>: {{ pan.department }}</td>
                        <th>Total Allow.</th>
                        <td>: P {{ total_allowance(pan) | formatNumber }}</td>
                    </tr>
                    <tr>
                        <th>Superior</th>
                        <td>: {{ pan.superior_name }}</td>
                        <th>Other Allow</th>
                        <td>: P {{ pan.other_allow | formatNumber }}</td>
                    </tr>
                    <tr>
                        <th>Remarks</th>
                        <td colspan="3">
                            <div class="well" v-if="pan.remarks">{{ pan.remarks }}</div>
                            <div v-else>--</div>
                        </td>   
                    </tr>
                    <tr>
                        <td colspan="4">
                            <div class="pull-right" v-if="!pan.is_saved">
                                <a class="btn btn-sm btn-white" @click="edit( pan )">
                                    <i class="fa fa-edit"></i> Update
                                </a>
                                <a class="btn btn-sm btn-white" @click="save_status( pan.id )">
                                    <i class="fa fa-save"></i> Save
                                </a>
                            </div>

                            <div class="pull-right">&nbsp;</div>

                            <div class="pull-right">
                                <a class="btn btn-sm btn-white" @click="createPdf( pan.id )">
                                    <i class="fa fa-print"></i> Print
                                </a>
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</div>
</template>

<script>
import jsPDF from 'jsPDF'
import numeral from 'numeral'
import moment from 'moment'
import imageJson from '../../../../../images/report_image.json'

export default {
    props: [
        'employee',
        'pans',
        'latestPan'
    ],
    methods: {
        edit( row_data ) {
            this.$emit('edit', row_data)
        },
        save_status( id ){
            this.$emit('saveStatus', id)
        },
        get_pan_full_details(id, callback) {
            return new Promise((resolve) => {
                axios.get(`employee/${this.employee.id}/pan/${id}`).then(response => {
                    resolve(response.data)
                })
            })
        },
        total_allowance: function (pan) {
            let total_allowance = 0
            total_allowance += pan.rice_allow
            total_allowance += pan.laundry_allow
            total_allowance += pan.clothing_allow
            total_allowance += pan.medical_allow
            total_allowance += pan.ob_allow
            total_allowance += pan.ecola
            return total_allowance
        },
        createPdf(pan_id) {
            this.get_pan_full_details(pan_id).then( response => {
                var pans = response.data
                var pan = pans.pan
                var old_pan = pans.old_pan

                var total_allowance = pan.total_allowance
                var total_salary = pan.total_salary
                var first_remarks = `13th : Php ${numeral(pan.pay_13th).format("0,0.00")} / OTHER ALLOWNCES : Php ${numeral(pan.other_allow).format("0,0.00")}`
                
                var imgData = imageJson.employee_pan.image
                var doc = new jsPDF('p', 'in','letter')

                doc.addImage(imgData, 'JPEG', .25, .25, 8, 11)

                var pan_details = [
                    {
                        "text": this.employee.last_name,
                        "top_position": 1.69,
                        "left_position": 1.58,
                        "font_weight": "bold",
                    },
                    {
                        "text": this.employee.first_name,
                        "top_position": 1.69,
                        "left_position": 3.5,
                        "font_weight": "bold",
                    },
                    {
                        "text": this.employee.middle_name,
                        "top_position": 1.69,
                        "left_position": 5.11,
                        "font_weight": "bold",
                    },
                    {
                        "text": moment(pan.created_at).format("MMM d, YYYY"),
                        "top_position": 1.69,
                        "left_position": 7.51,
                    },
                    {
                        "text": pan.job_title,
                        "top_position": 2.24,
                        "left_position": 1.85,
                    },
                    {
                        "text": pan.department,
                        "top_position": 2.24,
                        "left_position": 5.03,
                    },
                    {
                        "text": this.employee.display_hired_date,
                        "top_position": 2.24,
                        "left_position": 7.53,
                    },
                    {
                        "text": first_remarks,
                        "top_position": 8.74,
                        "left_position": 0.5,
                        "align": '',
                        "font_weight": "bold",
                        "font_size": 10
                    },
                    {
                        "text": this.employee.full_name,
                        "top_position": 9.85,
                        "left_position": 5.33,
                        "font_weight": "bold",
                    },
                ]

                // PAN Nature
                var pan_natures = [
                    {
                        "text": "TRAINEE",
                        "top_position": 2.85,
                        "left_position": 0.8,
                    },
                    {
                        "text": "REGULAR",
                        "top_position": 3.1,
                        "left_position": 1.18,
                    },
                    {
                        "text": "PROBATIONARY",
                        "top_position": 3.36,
                        "left_position": 1.18,
                    },
                    {
                        "text": "CONTRACTUAL",
                        "top_position": 3.8,
                        "left_position": 1.18,
                    },
                    {
                        "text": "PROMOTION",
                        "top_position": 4.07,
                        "left_position": 0.8,
                    },
                    {
                        "text": "TRANSFER",
                        "top_position": 4.34,
                        "left_position": 0.8,
                    },
                    {
                        "text": "RECLASSIFICATION",
                        "top_position": 4.60,
                        "left_position": 0.8,
                    },
                    {
                        "text": "SALARY",
                        "top_position": 4.88,
                        "left_position": 0.8,
                    },
                    {
                        "text": "SEPARATION",
                        "top_position": 5.15,
                        "left_position": 0.8,
                    },
                    {
                        "text": "OTHER",
                        "top_position": 5.15,
                        "left_position": 0.8,
                    },
                ]
                var pan_nature = []
                for (var i in pan_natures) {
                    let nature = pan_natures[i]

                    if(nature.text == pan.nature) {
                        pan_nature = [
                            {
                                "text": "x",
                                "top_position": nature.top_position,
                                "left_position": nature.left_position,
                                "align": 'center',
                                "font_weight": "bold",
                                "font_size": 9
                            }
                        ]
                    }
                }
                
                var old_pan_details = []
                if(old_pan) {
                    var old_total_allowance = old_pan.total_allowance
                    var old_total_salary = old_pan.total_salary
                    old_pan_details = [
                        {
                            "text": old_pan.department,
                            "top_position": 2.85,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.department,
                            "top_position": 3.1,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.job_title,
                            "top_position": 3.36,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.superior_name,
                            "top_position": 3.8,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.pay_class,
                            "top_position": 4.07,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.basic_salary,
                            "top_position": 4.34,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_total_allowance,
                            "top_position": 4.60,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.other_allow,
                            "top_position": 4.88,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_total_salary,
                            "top_position": 5.15,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.basic_salary,
                            "top_position": 6.12,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.rice_allow,
                            "top_position": 6.78,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.laundry_allow,
                            "top_position": 6.98,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.clothing_allow,
                            "top_position": 7.17,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.ob_allow,
                            "top_position": 7.37,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_pan.ecola,
                            "top_position": 7.57,
                            "left_position": 5.2,
                        },
                        {
                            "text": old_total_salary,
                            "top_position": 7.76,
                            "left_position": 5.2,
                        },
                    ]
                }
                

                var new_pan_details = [    
                    {
                        "text": pan.department,
                        "top_position": 2.85,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.department,
                        "top_position": 3.1,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.job_title,
                        "top_position": 3.36,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.superior_name,
                        "top_position": 3.8,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.pay_class,
                        "top_position": 4.07,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.basic_salary,
                        "top_position": 4.34,
                        "left_position": 7.13,
                    },
                    {
                        "text": total_allowance,
                        "top_position": 4.60,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.other_allow,
                        "top_position": 4.88,
                        "left_position": 7.13,
                    },
                    {
                        "text": total_salary,
                        "top_position": 5.15,
                        "left_position": 7.13,
                        "font_weight": "bold",
                    },
                    {
                        "text": pan.basic_salary,
                        "top_position": 6.12,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.rice_allow,
                        "top_position": 6.78,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.laundry_allow,
                        "top_position": 6.98,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.clothing_allow,
                        "top_position": 7.17,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.ob_allow,
                        "top_position": 7.37,
                        "left_position": 7.13,
                    },
                    {
                        "text": pan.ecola,
                        "top_position": 7.57,
                        "left_position": 7.13,
                    },
                    {
                        "text": total_salary,
                        "top_position": 7.76,
                        "left_position": 7.13,
                        "font_weight": "bold",
                    }
                ]

                pan_details = pan_details.concat(old_pan_details, new_pan_details, pan_nature)

                for (var i in pan_details) {
                    var detail = pan_details[i]
                    
                    doc.setFontType(('font_weight' in detail) ? detail.font_weight : 'normal')
                    doc.setFontSize(('font_size' in detail) ? detail.font_size : 9)

                    var text = detail.text

                    if (text === parseInt(text)) {
                        text =  (text > 0) ? 'Php ' + numeral(text).format("0,0.00") : '--'
                    }
                    
                    let align = ('align' in detail) ? detail.align : 'center'
                    doc.text(text,  detail.left_position, detail.top_position, align)
                }
                
                // Remarks
                if(pan.remarks != null && pan.remarks != '') {
                    var remarks = doc.splitTextToSize(pan.remarks, 7.6)
                    doc.setFontType('normal')
                    doc.setFontSize(9)
                    doc.text(remarks, 0.5, 8.89)
                }
                
                window.open(doc.output('bloburl'), '_blank');
            })
        }
    }
}
</script>
